#ifndef PROGCOMMON_H_
#define PROGCOMMON_H_

#include "llvm/Support/Compiler.h"
#include "llvm/Support/CommandLine.h"
/* Declarations used by multiple modules */

#if defined(__APPLE__)
# undef CPLEX_AVAILABLE
# undef FPU_CONTROL_AVAILABLE
#else
# define CPLEX_AVAILABLE
# define FPU_CONTROL_AVAILABLE
#endif

namespace llvm
{
#define THRESHOLD .00000001 /* fp tolerance */ /* 3e-16 */
#define UNALLOCED (INT_MIN)
#define UNREACHABLE (HUGE_VAL)
#define MAX_ITER (10000)

	typedef short index_type;
	typedef short commod_type;

	extern cl::opt<int> flag_prog_ra_iter;
	extern cl::opt<bool> flag_prog_ra_max_iter;
	extern cl::opt<bool> TiedConstraints;
	extern cl::opt<bool> CrossBlockAntis;
	extern cl::opt<bool> DisableCoalescing;
#ifndef NDEBUG
	extern cl::opt<int>DebugPRA;
	extern cl::opt<bool>DebugPathsPRA;
#else
	extern const bool DebugPRA;
	extern const bool DebugPathsPRA;
#endif

	struct mcnf_block;
	struct mcnf_node;
	struct mcnf_edge;
	class GlobalMCNF;
	class AllocClassMap;
	class AllocationClassInfo;

	/* Global variables (everyone uses them..) */
	extern const AllocationClassInfo *alloc_classes;
}
#endif /*PROGCOMMON_H_*/
