#ifndef X86ALLOCATIONCLASSINFO_H_
#define X86ALLOCATIONCLASSINFO_H_

#include "llvm/PrincipledBackend/AllocationClassInfo.h"
#include "X86TargetAsmInfo.h"
#include "X86.h"

namespace llvm
{

class X86TargetMachine;

class X86AllocationClassInfo : public AllocationClassInfo
{
protected:
	//simple cost model
	int loadCost;
	int storeCost;
	int moveCost;
	int intConstCost;
	int fpConstCost;
	int memConstCost;
	
	
public:		
	
	enum classIds {NearMem,LargeConst};
	
	X86AllocationClassInfo(const X86TargetMachine &tm);
	virtual ~X86AllocationClassInfo() {}
	virtual bool usableAcrossBlocks(int c) const;
	virtual int getInsnCost(MachineInstr *MI, int op_index, int c) const;
	virtual unsigned numCalleeSaves() const;
	virtual unsigned numCallerSaves() const;
	virtual void initialize();

protected:
	virtual int computeMoveCost(unsigned src, unsigned dst);
	virtual int getInsnSizeCost(MachineInstr *MI, int op_index, int c) const;
	virtual int getInsnSpeedCost(MachineInstr *MI, int op_index, int c) const;
	
	virtual void setupClasses();
};

}

#endif /*X86ALLOCATIONCLASSINFO_H_*/
