#include "X86SimpleAllocationClassInfo.h"
#include "X86TargetMachine.h"

namespace llvm
{

void X86SimpleAllocationClassInfo::setupClasses()
{
	std::vector<unsigned> abcd(4), disi(2), fp(7), xmm(8);
	abcd[0] = X86::EAX; abcd[1] = X86::EDX; abcd[2] = X86::ECX; abcd[3] = X86::EBX;
	disi[0] = X86::ESI; disi[1] = X86::EDI;

	//fp and xmm at least are consecutive
	for(int i = 0; i < 7; i++)
	{
		fp[i] = X86::FP0+i;
		xmm[i] = X86::XMM0+i;
	}
	xmm[7] = X86::XMM7;

	addRegisterClass(&X86::GR32_RegClass, abcd, "int4"); //eax,edx,ecx,ebx
	addRegisterClass(&X86::GR32RegClass, disi, "int2"); //edi, esi

	addRegisterClass(&X86::RFP80RegClass, fp, "fp");
	addRegisterClass(&X86::FR64RegClass, xmm, "xmm");

	addMemoryClass(-1, NearMem);
	addConstantClass(LargeConst);
}

X86SimpleAllocationClassInfo::X86SimpleAllocationClassInfo(
		const X86TargetMachine &tm) :
	X86AllocationClassInfo(tm)
{

}


}
