#ifndef X86SIMPLEALLOCATIONCLASSINFO_H_
#define X86SIMPLEALLOCATIONCLASSINFO_H_

#include "llvm/PrincipledBackend/AllocationClassInfo.h"
#include "X86AllocationClassInfo.h"
#include "X86TargetAsmInfo.h"
#include "X86.h"

namespace llvm
{

class X86TargetMachine;

/* A simplified model where we ignore register preferencing and just
 * deal with large classes (int, fp, xmm, mem, const) */
class X86SimpleAllocationClassInfo : public X86AllocationClassInfo
{
public:

	enum classIds {NearMem,LargeConst};

	X86SimpleAllocationClassInfo(const X86TargetMachine &tm);
	virtual ~X86SimpleAllocationClassInfo() {}
	virtual bool hasMultiRegClasses() const { return true; }

	virtual unsigned getSelfMoveCost(int c) const
	{
		return moveCost;
	}
protected:
	virtual void setupClasses();
};

}

#endif /*X86ALLOCATIONCLASSINFO_H_*/
